/*****************************************************************************/

/*
 *      define.h -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *                                Pascal Cannenterre <pascal_cannenterre@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#ifndef __DEFINE_H__
#define __DEFINE_H__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <math.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>


#include <X11/Xlib.h>

#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#ifdef DEBUG
#define G_MESSAGE(args...) g_message(args)
#else
#define G_MESSAGE(args...)
#endif

// FMP API.
#define _DEFINE_FMP_TYPES_
#include "fmp.h"

// FMP message queue access.
#include "novaclient.h"

// Analog overlay settings library.
#include "settingsheader.h"

#define UNUSED_ARG 0xdeadbeef

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

extern Display *dpy;
extern int scr;

extern DWORD xresolution;
extern DWORD yresolution;
extern DWORD depth;
extern DWORD freq;

extern GtkWidget *window;

extern char * PLAYER_mode;
extern int pid;
extern int pidMPEGServer;
extern BOOL b_playing; /* flag to know if a file is being played ... */
extern BOOL b_msg_connect_ready; /* flag to know if I can connect to the message queue ... */
extern BOOL b_vga; /* flag to follow the TV/VGA out state */
extern char * str_do_loop;

/* interface windows */

extern GtkWidget *filew;
extern GtkWidget *Configuration;

#endif /* DEFINE   */
