/*****************************************************************************/

/*
 *      gtk_callbacks.h -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *                                Pascal Cannenterre <pascal_cannenterre@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#ifndef __GTK_CALLBACKS_H__
#define __GTK_CALLBACKS_H__

void loadconfig();

gboolean window_move_toplevel (GtkWidget * , GdkEventConfigure * , gpointer );

gboolean window_move_drawingarea (GtkWidget * , GdkEventConfigure * , gpointer );

void file_ok_sel( GtkWidget *, GtkFileSelection * );

void print_hello( GtkWidget *, gpointer );

void toolbar_cb (GtkWidget * , gpointer );
void close_cb (GtkWidget * , gpointer );
void play_cb (GtkWidget * , gpointer );
void stop_cb (GtkWidget * , gpointer );
void pause_cb (GtkWidget * , gpointer );

void switch_TVout_cb(GtkWidget * , gpointer );
void fullscreen_on_cb (GtkWidget * , gpointer);
gboolean fullscreen_off_cb(GtkWidget *, GdkEvent *, gpointer);

void set_mute(const BOOL);
void updateAudio(int , int );
void set_TVmode(DWORD);
void volume_changed( GtkAdjustment *, GtkAdjustment *);
void balance_changed( GtkAdjustment *,GtkAdjustment *);
void brightness_changed( GtkAdjustment *,gpointer);
void contrast_changed( GtkAdjustment *,gpointer);
void saturation_changed( GtkAdjustment *,gpointer);

void C_Ok_clicked( GtkWidget *, gpointer);

void switch_overlay_back();

#endif /* CALLBACKS */
