/*****************************************************************************/

/*
 *      callbacks.c -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#include "define.h"

#include "callbacks.h"
#include "interface.h"

// cannot #include <X11/extensions/xf86vmode.h> because BOOL and BYTE conflict.

Bool XF86VidModeGetViewPort(
			    Display *display,
			    int screen,
			    int *x_return,
			    int *y_return);

gboolean
window_move                            (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
	gint x,y,xof,yof,width,height;
	GtkWidget *window;
	DWORD FMPreturn;
	
	window=gtk_widget_get_toplevel(widget);
	
	gdk_window_get_origin(window->window , &x ,&y);
	gdk_window_get_size(window->window ,&width,&height);
	
	G_MESSAGE("New position window x=%d y=%d size w = %d  h = %d\n",x,y,width,height);
	
	// be careful of viewport.
	if (!XF86VidModeGetViewPort(dpy,scr,&xof,&yof)) exit(1);

	// change the overlay position and overlay size
	FMPreturn=FMPSetDestination ((DWORD)(x-xof),(DWORD)(y-yof),(DWORD)width,(DWORD)height);
	G_MESSAGE("change the window size or position return: %ld",FMPreturn);	
	
	return FALSE;
}

