/*****************************************************************************/

/*
 *      quasar.h -- NetStream2000 EM8400 (quasar) ioctls
 *
 *      Copyright (C) 1999-2000  Sigma Designs
 *                    written by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *                           and Howard G. Page
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

// PCI bus scanning constants
#define PCI_VENDOR_ID_SIGMAD	     0x1105
#define PCI_DEVICE_ID_SIGMAD_PCICARD 0x8400

// the ioctl numbers I chose
#define IOCTL_GET_PIOMAPSIZE                       0x1233
#define IOCTL_DMABUF_ALLOC                         0x1234
#define IOCTL_DMABUF_FREE                          0x1235
#define IOCTL_TRANSLATE_PROCESSVIRTUAL_TO_PHYSICAL 0x1236
#define IOCTL_SEND_PID                             0x1237
#define IOCTL_SEND_IRQ_STATUS_REGISTER             0x1238

// mapping primitives
#define REMAP_PIO              0x1000
#define REMAP_DMA              0x2000

// what appears in /proc/interrupts
#define INTERRUPT_ENTRY_NAME "EM8400"

int quasar_init(void);
int quasar_cleanup(void);
