/*
 * $Workfile: geodeioctl.h $
 * $Revision: 22 $
 *
 * File Contents: This file contains the  the Geode frame buffer
 *                device driver specific ioctl functions prototypes.
 *                All the geode frame buffer driver ioctl functions
 *                uses the durango library to access the hardware.
 *
 * Project:       Geode Frame buffer device driver
 *
 */

/* 
 * NSC_LIC_ALTERNATIVE_PREAMBLE
 *
 * Revision 1.0
 *
 * National Semiconductor Alternative GPL-BSD License
 *
 * National Semiconductor Corporation licenses this software 
 * ("Software"):
 *
 * Geode frame buffer driver
 *
 * under one of the two following licenses, depending on how the 
 * Software is received by the Licensee.
 * 
 * If this Software is received as part of the Linux Framebuffer or
 * other GPL licensed software, then the GPL license designated 
 * NSC_LIC_GPL applies to this Software; in all other circumstances 
 * then the BSD-style license designated NSC_LIC_BSD shall apply.
 *
 * END_NSC_LIC_ALTERNATIVE_PREAMBLE */

/* NSC_LIC_BSD
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * Geode frame buffer driver
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c) 1999-2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * END_NSC_LIC_BSD */

/* NSC_LIC_GPL
 *
 * National Semiconductor Corporation Gnu General Public License for 
 *
 * Geode frame buffer driver
 *
 * (GPL License with Export Notice)
 *
 * Copyright (c) 1999-2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted under the terms of the GNU General 
 * Public License as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later version  
 *
 * In addition to the terms of the GNU General Public License, neither 
 * the name of the National Semiconductor Corporation nor the names of 
 * its contributors may be used to endorse or promote products derived 
 * from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE, 
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE. See the GNU General Public License for more details. 
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this file; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * END_NSC_LIC_GPL */

#ifndef __GEODEIOCTL_H_SEP_20
#define __GEODEIOCTL_H_SEP_20

int geodefb_ioctl_ext(struct inode *inode, 
                      struct file *file, 
                      u_int cmd,
                      u_long arg, 
                      int con,
 		      struct fb_info *info);

void Init_Dispatch_Table(void);
     
/* Dispatch Functions */
int Nscgfxfn_Unsupported(void *pvarg);

int Nscgfxfn_getadapterinfo(void *pvarg);
int Nscgfxfn_setsoftvgastate(void *pvarg);
int Nscgfxfn_getsoftvgastate(void *pvarg);
int Nscgfxfn_waituntilidle(void *pvarg);
int Nscgfxfn_waitverticalblank(void *pvarg);
int Nscgfxfn_setcrtstate(void *pvarg);
int Nscgfxfn_writereg(void *pvarg);
int Nscgfxfn_readreg(void *pvarg);

/* display hardware related function */
int Nscgfxfn_ismodesupported(void *pvarg);
int Nscgfxfn_setdisplaymode(void *pvarg);
int Nscgfxfn_getdisplaymode(void *pvarg);
int Nscgfxfn_setdisplaybpp(void *pvarg);
int Nscgfxfn_getdisplaybpp(void *pvarg);
int Nscgfxfn_setdisplaypitch(void *pvarg);
int Nscgfxfn_getdisplaypitch(void *pvarg);
int Nscgfxfn_setdisplayoffset(void *pvarg);
int Nscgfxfn_getdisplayoffset(void *pvarg);
int Nscgfxfn_getrefreshfromdotclock(void *pvarg);
int Nscgfxfn_getdisplaytiming(void *pvarg);
int Nscgfxfn_setdisplaytiming(void *pvarg);
int Nscgfxfn_setdisplaypaletteentry(void *pvarg);
int Nscgfxfn_getdisplaypaletteentry(void *pvarg);
int Nscgfxfn_setdisplaypalette(void *pvarg);
int Nscgfxfn_getdisplaypalette(void *pvarg);
int Nscgfxfn_setfixedtiming(void *pvarg);

/* cursor related function */
int Nscgfxfn_setcursorenable(void *pvarg);
int Nscgfxfn_getcursorenable(void *pvarg);
int Nscgfxfn_setcursorcolors(void *pvarg);
int Nscgfxfn_getcursorcolors(void *pvarg);
int Nscgfxfn_setcursorposition(void *pvarg);
int Nscgfxfn_getcursorposition(void *pvarg);
int Nscgfxfn_setcursorshape32(void *pvarg);

/* render related function */
int Nscgfxfn_setsolidpattern(void *pvarg);
int Nscgfxfn_setsolidsource(void *pvarg);
int Nscgfxfn_setmonopattern(void *pvarg);
int Nscgfxfn_setrasteroperation(void *pvarg);
int Nscgfxfn_patternfill(void *pvarg);
int Nscgfxfn_screentoscreenblt(void *pvarg);
int Nscgfxfn_screentoscreenxblt(void *pvarg);
int Nscgfxfn_bresenhamline(void *pvarg);

/* vga related function */
int Nscgfxfn_vgamodeswitch(void *pvarg);
int Nscgfxfn_vgaclearextended(void *pvarg);
int Nscgfxfn_vgapitch(void *pvarg);
int Nscgfxfn_vgarestore(void *pvarg);
int Nscgfxfn_vgasave(void *pvarg);
int Nscgfxfn_vgamode(void *pvarg);

/* compression related function */
int Nscgfxfn_setcompressionstate(void *pvarg);
int Nscgfxfn_getcompressionstate(void *pvarg);
int Nscgfxfn_setcompressionparams(void *pvarg);
int Nscgfxfn_getcompressionparams(void *pvarg);

/* panel related function */
int Nscpnlfn_enabledinbios(void *pvarg);
int Nscpnlfn_infofrombios(void *pvarg);
int Nscpnlfn_setpanelparams(void *pvarg);
int Nscpnlfn_getpanelparams(void *pvarg);
int Nscpnlfn_initpanel(void *pvarg);
int Nscpnlfn_savepanel(void *pvarg);
int Nscpnlfn_restorepanel(void *pvarg);
int Nscpnlfn_powerup(void *pvarg);
int Nscpnlfn_powerdown(void *pvarg);

/* TV related function */
int Nscgfxfn_settvparams(void *pvarg);
int Nscgfxfn_gettvparams(void *pvarg);
int Nscgfxfn_settvtiming(void *pvarg);
int Nscgfxfn_gettvtiming(void *pvarg);
int Nscgfxfn_settvenable(void *pvarg);
int Nscgfxfn_gettvenable(void *pvarg);
int Nscgfxfn_istvmodesupported(void *pvarg);

/* video related function */
int Nscgfxfn_setvideoenable(void *pvarg);
int Nscgfxfn_setvideoformat(void *pvarg);
int Nscgfxfn_setvideosize(void *pvarg);
int Nscgfxfn_setvideosize(void *pvarg);
int Nscgfxfn_setvideooffset(void *pvarg);
int Nscgfxfn_setvideowindow(void *pvarg);
int Nscgfxfn_setvideoscale(void *pvarg);
int Nscgfxfn_setvideofilter(void *pvarg);
int Nscgfxfn_setvideocolorkey(void *pvarg);
int Nscgfxfn_setvideodownscale_enable(void *pvarg);
int Nscgfxfn_setvideodownscale_config(void *pvarg);
int Nscgfxfn_setvideodownscale_coefficients(void *pvarg);
int Nscgfxfn_setvideosource(void *pvarg);
int Nscgfxfn_setvideointerlaced(void *pvarg);
int Nscgfxfn_setvideocolorspace(void *pvarg);
int Nscgfxfn_setvideocursor(void *pvarg);
int Nscgfxfn_setvideorequest(void *pvarg);
int Nscgfxfn_setvideoalphaenable(void *pvarg);
int Nscgfxfn_setvideoalphawindow(void *pvarg);
int Nscgfxfn_setvideoalphavalue(void *pvarg);
int Nscgfxfn_setvideoalphapriority(void *pvarg);
int Nscgfxfn_setvideoalphacolor(void *pvarg);
int Nscgfxfn_setvideoalpharegion(void *pvarg);
int Nscgfxfn_setvideooutsidealpha(void *pvarg);
int Nscgfxfn_setvideopalette(void *pvarg);
int Nscgfxfn_getvideoinfo(void *pvarg);
#endif
