/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor Video Middleware
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 ********************************************************************************
 * File Name        : nscparam.h							*
 * 										*
 * Project Name     : ASTB							*
 *										*
 * Subsystem Name   : Streamer	                                                *
 *                               						*
 * Module Name      : Param							*
 *										*
 * Author Name	    : Niraj Kumar						*
 *										*
 * Language         : C++							*
 *										*
 * Date             : 12/03/00							*
 *										*
 * Description      : This file will contain the include files and function     *
 *		      prototype, which are used as an interface with the 	*
 *		      middleware API's.						*
 *										*
 ********************************************************************************/



#ifndef _NSCPARAM_H_
#define _NSCPARAM_H_

#include <stdio.h>


enum { CPLAY=100,CFF, CREV,CSKIP,CMUTE,CPAUSE,CSTP,CLOOP,CSCROLL,CCNTSER,CGETDIR,COPEN,CADIOL,CADIOR,CQUT};

#define TRUE 1
#define  FALSE 0

int GuiFltkThread(int ,char **);

typedef  struct 
{ 
	char flname[50];
  	char type;
  	unsigned long flsz;
}DIR_RECORD;

typedef struct  
{	int NoElements;
	DIR_RECORD *dir_record;
}DIR_LIST ;





/************************************************************************
 *Class Description : This class contains the functions as its object   *
 *                    which are used as an interface with the middleware*
 *		      API's.						*
  ************************************************************************/

class Param
{
	private:
        char ServerName[40];
        char FileName[100];
        DIR_LIST  *dirList;
        char DirName[50];
	char ErrMsg[100];
	
	int audioVolL;
        int audioVolR;
 
        bool Play;
        bool Pause;
        bool Stop;
        bool  FF;
        bool  Rev;
 
        bool Open;
        bool Read;
        bool Write;
        bool Loop;
        bool Mute;
        bool Cont;
        bool GetDir;
	bool Quit;
 
        int ScrolPt;
        int ScrolPoint;
 
        int butvalue;
        int ButPress;
	int ErFlg ;


 	int owner;
 
        bool StatusCh;      
public:

	Param();
	bool  GetStatus();
	Show();
	int GetKey();
	int GetKeyWithValue(int *butvalue);
	int GetServNameDot(char *srvname) ;
	int SetServNameDot(char *srvname) ;
	int GetFlName(char * flname) ; 
	int SetFlName(char * flname);
	int SetDirectory(char *str);
	char * GetRmtCWD();
	DIR_LIST *GetDirectory();
	int SetFilename4Dir(int indx, char * str1);
	int SetFileType4Dir(int indx,char type);
	char GetFileType4Dir(int indx);
	void GetFilename4Dir(int indx ,char *str);
	int SetNoRec4Dir(int index);
	int GetNoRec4Dir();
	int SetOpen();
	int SetCont();
        int SetPlay();
	int SetPause();    // toggle
	int SetStop();
	int SetQuit();
	int SetFF();
	int SetRev();
	int SetRead()   ; // toggle
	int SetWrite() ;    // toggle
	int SetLoop() ;  // toggle
	int SetMute();
	int SetScrolpt(int );
	int GetScrolpt()      ;  
	int GetScrolPoint();
	int UpdateScrolpt(int )  ;
	SetOwner(int );
	int GetOwner();
	void postErMsg(char *);
	char *getErMsg();
	int SetAudioL(int);
 	int SetAudioR(int);
	int GetAudioL();
	int GetAudioR();
	

};
#endif
