/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 *    <STOPSHIP:NSC Digital Video API>
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c) <STOPSHIP:2000-2001> 
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (<STOPSHIP:2000-2001>) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 */

/********************************************************************************
 * File Name        : nscstrapi.cpp						*
 * 										*
 * Subsystem Name   : IA Software                                               *
 *                               						*
 * Module Name      : Streaming							*
 *										*
 * Author Name	    : Niraj Kumar						*
 *										*
 * Language         : C								*
 *										*
 * Date             : 								*
 *										*
 * Description      : This file defines the various API's which will called by	*
 *                    the GUI to perform various operations.			*
 *										*
 ********************************************************************************/




#include <unistd.h>
#include "nscparam.h"
#include "nscstrapi.h"


Param *ptrParam;

char srvname[100];
extern int GetTermin();
extern int NscOpenPlayer();
extern Param *GetPtrToParam();
static int NoRec =0;



/************************************************************************
 * Title	: NscStrInit						*
 *									*
 * Description	: This function is to do the initialization.		*
 *									*
 * Parameters	: None	                                                *
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrInit()
{
  	if(-1 == NscOpenPlayer())
	   return 0;
	  printf(" arun \n");
	  sleep(2); 
    	if( 0 >= (ptrParam = GetPtrToParam()))
	  return 0;	   	

	ptrParam->SetFlName("c://");
	return 1;
         	
}





/************************************************************************
 * Title	: NscStrSetSrvName					*
 *									*
 * Description	: This function takes the server name as the input and	*
 *		  then selects that server.				*
 *									*
 * Parameters	: srvname - Server name.                                *
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrSetSrvName(char * srvname)
{
	return ptrParam->SetServNameDot(srvname);
}






/************************************************************************
 * Title	: NscStrGetSrvName					*
 *									*
 * Description	: This function is to get the server name selected 	*
 *									*
 * Parameters	: None.			                                *
 *									*
 * Returns	: Returns the server name currently selected.		*
 ************************************************************************/

char * NscStrGetSrvName()
{
	ptrParam->GetServNameDot(srvname);
	return srvname ;
}





/************************************************************************
 * Title	: NscStrHook2Srv					*
 *									*
 * Description	: This function is to coonect with the server selected  *
 *									*
 * Parameters	: None.			                                *
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrHook2Srv()
{
	int servContFlag;


	for(int i=0;i<4;i++)
	{  	servContFlag = ptrParam->SetCont();
   		if(servContFlag  < 0 )   usleep(1000);
			else    break;
	}
     	if(servContFlag < 0)
     	{	
      		return 0;
	}	
	for(int i=0;i<14;i++)
	{
	 if( ptrParam->GetOwner() != 1) sleep(1);
	      else
	      {
		return 1;      
	      }
	}	
	return 0;	
}




/************************************************************************
 * Title	: NscStrUnHook2Srv					*
 *									*
 * Description	: This function is to coonect with the server selected  *
 *									*
 * Parameters	: None.			                                *
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrUnHook2Srv()
{

	int servContFlag;


	for(int i=0;i<4;i++)
	{  	servContFlag = ptrParam->SetCont();
   		if(servContFlag  < 0 )   usleep(1000);
			else    break;
	}
     	if(servContFlag < 0)
     	{	
      		return 0;
	}	
	for(int i=0;i<2;i++)
	{
	 if( ptrParam->GetOwner() != 1) sleep(1);
	      else
	      {
		return 0;      
	      }
	}	
	return 1;
}





/************************************************************************
 * Title	: NscStrHook2Srv					*
 *									*
 * Description	: This function is to  first select the server and then *
 *                connect to that server.				*
 *									*
 * Parameters	: srvname - Server name.			        *
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrHook2Srv(char  * srvname)
{
	int i,servContFlag;
  
  	if(0 == NscStrSetSrvName(srvname))  return 0;

	for(i=0;i<4;i++)
	{  	servContFlag = ptrParam->SetCont();
   		if(servContFlag  < 0 )   usleep(1000);
			else    break;
	}
     	if(servContFlag < 0)
     	{	// printf("\n Not able to connect to the  Server <%d> \n",servContFlag);
	       //  mlip_status->value(" Not ABle to connect to the server" );
      		return 0;
     	}

	for(i=0;i<14;i++)
	 {
	 if( ptrParam->GetOwner() != 1) sleep(1);
	      else
	      {
		return 1;      
	      }
	}	
	return 0;	
}





/************************************************************************
 * Title	: NscStrSelectFile					*
 *									*
 * Description	: This function is to select the input file name.	*
 *									*
 * Parameters	: cmpflname - Compelte file name.			*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int  NscStrSelectFile(char *cmpflname)
{
	 ptrParam->SetFlName(cmpflname);
         return 1;
}

/* Added by Chitra for checking if the selected file/dir is valid*/
/************************************************************************
 * Title	: NscStrCheckDirFile					*
 *									*
 * Description	: This function is to check if the selected file/dir	*
 *		  is valid.						*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/


int NscStrCheckSelectFile()
{
	int ret;
	ret = GetTermin();
	if(ret == 1)
		return 0;
	else
		return 1;
}

/************************************************************************
 * Title	: NscStrOpenCurrentFile					*
 *									*
 * Description	: This function is to open the file name selected to 	*
 *		  perform various operations on that.			*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/


int NscStrOpenCurrentFile()
{
   	return ptrParam->SetOpen();
	
}






/************************************************************************
 * Title	: NscStrOpenFile					*
 *									*
 * Description	: This function is to firest select and then open that  *
 *                file name selected to perform various operations on	*
 *		  that.							*
 *									*
 * Parameters	: cmpflname - Complete file name.			*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrOpenFile(char *cmpflname)
{

	if(0 == ptrParam->SetFlName(cmpflname) )
		return 0;
	usleep(10000);	
   	return ptrParam->SetOpen();
	
}





/************************************************************************
 * Title	: NscStrSetDirectory					*
 *									*
 * Description	: This function will select the directory whose path is *
 *		  given as the input. 					*
 *									*
 * Parameters	: cmpPath - Complete path of the directory.		*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/


int  NscStrSetDirectory(char *cmpPath)
{
   int setDirFlag =0;	
 	for(int i=0;i<4;i++)
	{
		setDirFlag = ptrParam->SetDirectory(cmpPath);
		if(setDirFlag <= 0) sleep(2);
	      		else   return 1;
	}
	return 0;	
	
}






/************************************************************************
 * Title	: NscStrGetNoFiles					*
 *									*
 * Description	: This function is to get the number of files in the  	*
 *		  directory selected.					*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrGetNoFiles()
{
	return ( NoRec = (ptrParam->GetNoRec4Dir()));
	

}







/************************************************************************
 * Title	: NscStrGetFileList					*
 *									*
 * Description	: This function will get all the files name of the      *
 *		  directory in the output buffer.		 	*
 *									*
 * Parameters	: buf -  Buffer to get the files name of the selected 	*
 *			 directory.					*
 *		  sz  -  Size of the buffer.				*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/


int NscStrGetFileList(char *buf,int sz)
{

     if( NoRec < (sz/80 ) )
	       return 0;
	       	
     for(int i=0;i<NoRec;i++)
	{
		ptrParam->GetFilename4Dir(i,buf + (i*80));
	}
	
       return 1;	
	
}





/************************************************************************
 * Title	: NscStrGetFileType					*
 *									*
 * Description	: This function is to get the files type.	  	*
 *									*
 * Parameters	: index  - Index of the file whose type will be passed.	*
 *									*
 * Returns	: Returns the file type.				*
 ************************************************************************/

char NscStrGetFileType(int index)
{
     char  type;
     type = ptrParam->GetFileType4Dir(index-1);
     return type;	
}






/************************************************************************
 * Title	: NscStrGetPlayStatus					*
 *									*
 * Description	: This function is to get the scroll point.	  	*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: The scroll point value.				*
 ************************************************************************/
int  NscStrGetPlayStatus()
{
   int new_value;
   
   new_value = ptrParam->GetScrolPoint(); 

   return new_value;

}






/************************************************************************
 * Title	: NscStrPlaySkip					*
 *									*
 * Description	: This function is to set the scroll point value.  	*
 *									*
 * Parameters	: offset - The index to which the scroll point value has*
 *		  to be set.						*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrPlaySkip(int offset)
{	
	
	return ptrParam->SetScrolpt(offset);
	
}





/************************************************************************
 * Title	: NscStrPlay						*
 *									*
 * Description	: This function is to play the stream in normal mode.  	*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrPlay()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetPlay();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}




/************************************************************************
 * Title	: NscStrPlayFastForward					*
 *									*
 * Description	: This function is to do the fast forward operation on  *
 *		  the stream.					  	*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrPlayFastForward()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetFF();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}






/************************************************************************
 * Title	: NscStrPlayReverse					*
 *									*
 * Description	: This function is to do the reverse operation on the   *
 *		  stream.					  	*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrPlayReverse()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetRev();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}






/************************************************************************
 * Title	: NscStrStop						*
 *									*
 * Description	: This function is to do the stop operation on streams. *
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrStop()
{
	int retval;
	printf("Coming to NscStrStop() \n");

	for(int i=0;i<3;i++ )
	 {
		retval = ptrParam->SetStop();
		if(retval <0) usleep(1000);
		else
		{
			 return 1;
		}
	 }
	printf("Out of NscStrStop() \n");
     return 0;		 
		
}

/* Added by Chitra for clearing the screen on quitting */
/************************************************************************
 * Title	: NscStrQuit						*
 *									*
 * Description	: This function is to do the quit operation on streams. *
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrQuit()
{
	int retval;
	for(int i=0;i<3;i++ )
	{
		retval = ptrParam->SetQuit();
		if(retval <0) usleep(1000);
		else
		{
			 return 1;
		}
	}
     return 0;		 
}





/************************************************************************
 * Title	: NscStrMute						*
 *									*
 * Description	: This function is to do the Mute operation on streams. *
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrMute()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetMute();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}





/************************************************************************
 * Title	: NscStrLoop						*
 *									*
 * Description	: This function is to do the Loop operation on streams. *
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrLoop()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetLoop();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}







/************************************************************************
 * Title	: NscStrPause						*
 *									*
 * Description	: This function is to do the stop operation on streams. *
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrPause()
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetPause();
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}




/************************************************************************
 * Title	: NscStrSetLeftAudio					*
 *									*
 * Description	: This function is to adjust the left side audio.	*
 *									*
 * Parameters	: vol - Index to set the left audio.			*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrSetLeftAudio(int vol)
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetAudioL(vol);
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}






/************************************************************************
 * Title	: NscStrSetRightAudio					*
 *									*
 * Description	: This function is to adjust the right side audio.	*
 *									*
 * Parameters	: vol - Index to set the right audio.			*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

int NscStrSetRightAudio(int vol)
{
	int retval ;
	for(int i=0;i<3;i++ )
		 {
			retval = ptrParam->SetAudioR(vol);
			if(retval <0) usleep(1000);
				else
				{
				 return 1;
				}
		 }
     return 0;		 
		
}






/************************************************************************
 * Title	: NscStrErrMsg						*
 *									*
 * Description	: This function is to get the error messages in case of *
 *		  any error.						*
 *									*
 * Parameters	: None.							*
 *									*
 * Returns	: Success or failure.					*
 ************************************************************************/

char* NscStrErrMsg()
{

	return ptrParam->getErMsg();
}	

