/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor VidTest4linux for Microwindows
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * File Name      : dvd_gui.h                              *
 *                                                         *
 * Project Name   : ASTB                                   *
 *                                                         *
 * Module Name    : Integrated Test App                    *
 *                                                         *
 * Author Name    : Lakshmi B G                            *
 *                                                         *
 * Language       : C++                                    *
 *                                                         *
 * Date           : 2/02/01                                *
 *							   *
 * Description 	  : This file defines a class for dvd gui  *
 *		    buttons and dvd buttons callbacks 	   *
 **********************************************************/

#ifndef _DVDGUI_H
#define _DVDGUI_H

/* Installed middleware includes */
#include <vmwdvdapi.h>
#include <anlg_video.h>

/* User includes */
#include "includes.h"
#include "keypad_dvd.h"

/* Global Callback functions */
void Dvd_playctrl_cb(Fl_Widget*, void*);
void Dvd_ctrl_cb(Fl_Widget*, void*);
void Dvd_select_cb(Fl_Widget*, void*);
void Dvd_prog_sel_cb(Fl_Widget*, void*);
void Dvd_hide_cb(Fl_Widget*, void*);

/* Class for Dvd gui functionals */
class DvdGUI : public Fl_Box
{
	public:
		/* Play controls */
		Fl_Box*		ctrl_box;
		Fl_Group*	ctrl_grp;
		Fl_Button*	play_b;
		Fl_Button*	fwd_b;
		Fl_Button*	rev_b;
		Fl_Button*	pause_b;
		Fl_Button*	mute_b;
		Fl_Button* 	ft_sl;
		Fl_Button*	stop_b;

		/* Menu controls */	
		Fl_Box*		select_box;
		Fl_Group*	select_grp;
		Fl_Box*		select_titl;
		Fl_Button*	up_b;
		Fl_Button*	dn_b;
		Fl_Button*	left_b;
		Fl_Button*	right_b;
		Fl_Button*	select_b;
		Fl_Button*	ctrl_b;
		Fl_Button*	menu_b;

		/* Program select menu */
		Fl_Box*		prog_search_box;
		Fl_Group*	prog_search_grp;
		Fl_Box*		prog_search_titl;
		Fl_Button*	next_b;
		Fl_Button*	prev_b;
		Fl_Button*	top_b;
		Fl_Button*	chap_b;
		Fl_Button*	titl_b;
		Fl_Button*	goup_b;

		/* Language controls */
		Fl_Button*	dvd_subtitl_b;
		Fl_Button*	dvd_lang_b;
		Fl_Button*	dvd_angle_b;

		/* Key pad for chapter & title selections */
		Keypad_Dvd*	num_select;
		Fl_Button*	dvd_hide_b;

		/* Remote control position parameters */
		int topx, topy, width, ht;

		/* Constructor */
		DvdGUI(int x, int y, int w, int h, char *label=0);

		/* Member functions */
		void Create_gui();
		void hide();
		void show();
		
};

#endif
