/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor VidTest4linux for Microwindows
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
*/
#include<stdio.h>
#include<linux/fb.h>
#include<stdlib.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/mman.h>
#include<unistd.h>

#include "app_window.h"

int main(int argc,char** argv)
{
	/* Used for file descriptor of frame buf device */
	int fbfd = 0;	

	/* Structures defined in linux/fb.h to get fixed and visible
	   screen information */
        struct fb_var_screeninfo vinfo;

	/* Application Window positioning co-ordinates */
	int start_x = 0, start_y = 0, end_x = 0, end_y = 0;

	/* Application window width and height */
	int width = 0;
	int height = 0;	

	/* If number of arguments not equal to the desired */
	if(argc != 5)
	{
		start_x = 10;
		start_y = 0;
		width = 640;
		height = 480;
	}
	else	
	{
		start_x	= atoi(argv[1]);
		start_y = atoi(argv[2]);
		width   = atoi(argv[3]);
		height = atoi(argv[4]);
	}
	
	
        /* Open the file for reading and writing */
        fbfd = open("/dev/fb0", O_RDWR);
        if (!fbfd) 
	{
        	printf("Error: cannot open framebuffer device.\n");
           	exit(1);
        }
        printf("The framebuffer device  opened successfully.\n");

        /* Get variable screen information */
        if (ioctl(fbfd, FBIOGET_VSCREENINFO, &vinfo)) 
	{
        	printf("Error reading variable information.\n");
           	exit(3);
       	}
        close(fbfd); /* Closing the frame buffer device */

	printf("%dx%d \n", vinfo.xres, vinfo.yres);
	end_x = vinfo.xres;
	end_y = vinfo.yres;

	if(start_x >= 0 && start_y >= 0 && width <= end_x && height <= end_y)
	{ 
		/* Launching the stb integration application */
		AppMainWindow* app =  new AppMainWindow(start_x,start_y,width,height,end_x,end_y,"CYGNUS STB INTEGRATION");
	}
	else
	{
		printf("Invalid parameters \n");
		exit(-1);
	}
        return 0;
}
